#include <stdbool.h>
#define MAXIMALZAHL 16

struct Menge
{
  int elemente[MAXIMALZAHL];
  int anzahlElemente;
};

typedef struct Menge Menge;

Menge erzeugeLeereMenge(void)
{
  Menge m;
  m.anzahlElemente = 0;
  return m;
}

int zaehle(Menge m)
{
  return m.anzahlElemente;
}

bool enthaelt(Menge m, int z)
{
  for(int i = 0; i < m.anzahlElemente; i++)
  {
    if(m.elemente[i] == z)
    {
      return true;
    }
  }
  return false;
}

Menge fuegeHinzu(Menge m, int z)
{
  if(enthaelt(m, z))
  {
    return m;
  } 
  
  if(m.anzahlElemente >= MAXIMALZAHL)
  {
    return m; // mathematisch falsch; besser: Fehler signalisieren!
  }
  
  m.elemente[m.anzahlElemente] = z;
  m.anzahlElemente++;
  return m;
}

Menge schneide(Menge m1, Menge m2)
{
  Menge r = erzeugeLeereMenge();
  for(int i = 0; i < m1.anzahlElemente; i++)
  {
    int z = m1.elemente[i];
    if(enthaelt(m2, z))
    {
      r = fuegeHinzu(r, z); // korrigiert
    }
  }
  return r;
}

Menge vereinige(Menge m1, Menge m2)
{
  // To Do: Ist genug Platz da?
  for(int i = 0; i < m2.anzahlElemente; i++)
  {
    m1 = fuegeHinzu(m1, m2.elemente[i]); // korrigiert
  }  
  return m1;
}

int main( void )
{
  Menge a = erzeugeLeereMenge();
  a = fuegeHinzu(a, 42);
  a = fuegeHinzu(a, 13);
  a = fuegeHinzu(a, 7);
  int b = zaehle(a);
  bool c = enthaelt(a, 13);
  bool d = enthaelt(a, 100);
  
  return 0;
}
